]> arthur.barton.de Git - bup.git/blob - Makefile
Build docs via top Makefile
[bup.git] / Makefile
1
2 SHELL := bash
3 .DEFAULT_GOAL := all
4
5 # See config/config.vars.in (sets bup_python, among other things)
6 include config/config.vars
7
8 pf := set -o pipefail
9
10 define isok
11   && echo " ok" || echo " no"
12 endef
13
14 # If ok, strip trailing " ok" and return the output, otherwise, error
15 define shout
16 $(if $(subst ok,,$(lastword $(1))),$(error $(2)),$(shell x="$(1)"; echo $${x%???}))
17 endef
18
19 sampledata_rev := $(shell t/configure-sampledata --revision $(isok))
20 sampledata_rev := \
21   $(call shout,$(sampledata_rev),Could not parse sampledata revision)
22
23 current_sampledata := t/sampledata/var/rev/v$(sampledata_rev)
24
25 os := $(shell ($(pf); uname | sed 's/[-_].*//') $(isok))
26 os := $(call shout,$(os),Unable to determine OS)
27
28 CFLAGS := -Wall -O2 -Werror -Wno-unknown-pragmas $(PYINCLUDE) $(CFLAGS)
29 CFLAGS := -D_FILE_OFFSET_BITS=64 $(CFLAGS)
30 SOEXT:=.so
31
32 ifeq ($(os),CYGWIN)
33   SOEXT:=.dll
34 endif
35
36 ifdef TMPDIR
37   test_tmp := $(TMPDIR)
38 else
39   test_tmp := $(CURDIR)/t/tmp
40 endif
41
42 initial_setup := $(shell ./configure-version --update $(isok))
43 initial_setup := $(call shout,$(initial_setup),Version configuration failed))
44
45 config/config.vars: configure config/configure config/configure.inc \
46   $(wildcard config/*.in)
47         ./configure
48
49 bup_cmds := cmd/bup-python\
50   $(patsubst cmd/%-cmd.py,cmd/bup-%,$(wildcard cmd/*-cmd.py)) \
51   $(patsubst cmd/%-cmd.sh,cmd/bup-%,$(wildcard cmd/*-cmd.sh))
52
53 bup_deps := bup lib/bup/_version.py lib/bup/_helpers$(SOEXT) $(bup_cmds)
54
55 all: $(bup_deps) Documentation/all $(current_sampledata)
56
57 bup:
58         ln -s main.py bup
59
60 $(current_sampledata):
61         t/configure-sampledata --setup
62
63 define install-python-bin
64   set -e; \
65   sed -e '1 s|.*|#!$(bup_python)|; 2,/^# end of bup preamble$$/d' $1 > $2; \
66   chmod 0755 $2;
67 endef
68
69 PANDOC ?= $(shell type -p pandoc)
70
71 ifeq (,$(PANDOC))
72   $(shell echo "Warning: pandoc not found; skipping manpage generation" 1>&2)
73   man_md :=
74 else
75   man_md := $(wildcard Documentation/*.md)
76 endif
77
78 man_roff := $(patsubst %.md,%.1,$(man_md))
79 man_html := $(patsubst %.md,%.html,$(man_md))
80
81 INSTALL=install
82 PREFIX=/usr
83 MANDIR=$(DESTDIR)$(PREFIX)/share/man
84 DOCDIR=$(DESTDIR)$(PREFIX)/share/doc/bup
85 BINDIR=$(DESTDIR)$(PREFIX)/bin
86 LIBDIR=$(DESTDIR)$(PREFIX)/lib/bup
87
88 install: all
89         $(INSTALL) -d $(BINDIR) \
90                 $(LIBDIR)/bup $(LIBDIR)/cmd \
91                 $(LIBDIR)/web $(LIBDIR)/web/static
92         test -z "$(man_roff)" || install -d $(MANDIR)/man1
93         test -z "$(man_roff)" || $(INSTALL) -m 0644 $(man_roff) $(MANDIR)/man1
94         test -z "$(man_html)" || install -d $(DOCDIR)
95         test -z "$(man_html)" || $(INSTALL) -m 0644 $(man_html) $(DOCDIR)
96         $(call install-python-bin,bup,"$(BINDIR)/bup")
97         set -e; \
98         for cmd in $$(ls cmd/bup-* | grep -v cmd/bup-python); do \
99           $(call install-python-bin,"$$cmd","$(LIBDIR)/$$cmd") \
100         done
101         $(INSTALL) -pm 0644 \
102                 lib/bup/*.py \
103                 $(LIBDIR)/bup
104         $(INSTALL) -pm 0755 \
105                 lib/bup/*$(SOEXT) \
106                 $(LIBDIR)/bup
107         $(INSTALL) -pm 0644 \
108                 lib/web/static/* \
109                 $(LIBDIR)/web/static/
110         $(INSTALL) -pm 0644 \
111                 lib/web/*.html \
112                 $(LIBDIR)/web/
113 %/all:
114         $(MAKE) -C $* all
115
116 %/clean:
117         $(MAKE) -C $* clean
118
119 config/config.h: config/config.vars
120
121 lib/bup/_helpers$(SOEXT): \
122                 config/config.h \
123                 lib/bup/bupsplit.c lib/bup/_helpers.c lib/bup/csetup.py
124         @rm -f $@
125         cd lib/bup && \
126         LDFLAGS="$(LDFLAGS)" CFLAGS="$(CFLAGS)" "$(bup_python)" csetup.py build
127         cp lib/bup/build/*/_helpers$(SOEXT) lib/bup/
128
129 lib/bup/_version.py:
130         @echo "Something has gone wrong; $@ should already exist."
131         @echo 'Check "./configure-version --update"'
132         @false
133
134 t/tmp:
135         mkdir t/tmp
136
137 runtests: runtests-python runtests-cmdline
138
139 # The "pwd -P" here may not be appropriate in the long run, but we
140 # need it until we settle the relevant drecurse/exclusion questions:
141 # https://groups.google.com/forum/#!topic/bup-list/9ke-Mbp10Q0
142 runtests-python: all t/tmp
143         $(pf); cd $$(pwd -P); TMPDIR="$(test_tmp)" \
144           "$(bup_python)" wvtest.py t/t*.py lib/*/t/t*.py 2>&1 \
145             | tee -a t/tmp/test-log/$$$$.log
146
147 cmdline_tests := \
148   t/test-index.sh \
149   t/test-split-join.sh \
150   t/test-fuse.sh \
151   t/test-drecurse.sh \
152   t/test-cat-file.sh \
153   t/test-compression.sh \
154   t/test-fsck.sh \
155   t/test-index-clear.sh \
156   t/test-index-check-device.sh \
157   t/test-ls.sh \
158   t/test-tz.sh \
159   t/test-meta.sh \
160   t/test-on.sh \
161   t/test-restore-map-owner.sh \
162   t/test-restore-single-file.sh \
163   t/test-rm-between-index-and-save.sh \
164   t/test-sparse-files.sh \
165   t/test-command-without-init-fails.sh \
166   t/test-redundant-saves.sh \
167   t/test-save-creates-no-unrefs.sh \
168   t/test-save-restore-excludes.sh \
169   t/test-save-strip-graft.sh \
170   t/test-import-duplicity.sh \
171   t/test-import-rdiff-backup.sh \
172   t/test-xdev.sh \
173   t/test.sh
174
175 # For parallel runs.
176 # The "pwd -P" here may not be appropriate in the long run, but we
177 # need it until we settle the relevant drecurse/exclusion questions:
178 # https://groups.google.com/forum/#!topic/bup-list/9ke-Mbp10Q0
179 tmp-target-run-test%: all t/tmp
180         $(pf); cd $$(pwd -P); TMPDIR="$(test_tmp)" \
181           t/test$* 2>&1 | tee -a t/tmp/test-log/$$$$.log
182
183 runtests-cmdline: $(subst t/test,tmp-target-run-test,$(cmdline_tests))
184
185 stupid:
186         PATH=/bin:/usr/bin $(MAKE) test
187
188 test: all
189         if test -e t/tmp/test-log; then rm -r t/tmp/test-log; fi
190         mkdir -p t/tmp/test-log
191         ./wvtest watch --no-counts $(MAKE) runtests-python runtests-cmdline
192         ./wvtest report t/tmp/test-log/*.log
193
194 check: test
195
196 cmd/python-cmd.sh: config/config.vars Makefile
197         printf "#!/bin/sh\nexec %q \"\$$@\"" "$(bup_python)" \
198           >> cmd/python-cmd.sh.$$PPID.tmp
199         chmod u+x cmd/python-cmd.sh.$$PPID.tmp
200         mv cmd/python-cmd.sh.$$PPID.tmp cmd/python-cmd.sh
201
202 cmd/bup-%: cmd/%-cmd.py
203         rm -f $@
204         ln -s $*-cmd.py $@
205
206 cmd/bup-%: cmd/%-cmd.sh
207         rm -f $@
208         ln -s $*-cmd.sh $@
209
210 .PHONY: Documentation/all
211 Documentation/all: $(man_roff) $(man_html)
212
213 Documentation/substvars: $(bup_deps)
214         echo "s,%BUP_VERSION%,$$(./bup version --tag),g" > $@
215         echo "s,%BUP_DATE%,$$(./bup version --date),g" >> $@
216
217 Documentation/%.1: Documentation/%.md Documentation/substvars
218         $(pf); sed -f Documentation/substvars $< \
219           | $(PANDOC) -s -r markdown -w man -o $@
220
221 Documentation/%.html: Documentation/%.md Documentation/substvars
222         $(pf); sed -f Documentation/substvars $< \
223           | $(PANDOC) -s -r markdown -w html -o $@
224
225 .PHONY: Documentation/clean
226 Documentation/clean:
227         cd Documentation && rm -f *~ .*~ *.[0-9] *.html substvars
228
229 # update the local 'man' and 'html' branches with pregenerated output files, for
230 # people who don't have pandoc (and maybe to aid in google searches or something)
231 export-docs: Documentation/all
232         git update-ref refs/heads/man origin/man '' 2>/dev/null || true
233         git update-ref refs/heads/html origin/html '' 2>/dev/null || true
234         set -eo pipefail; \
235         GIT_INDEX_FILE=gitindex.tmp; export GIT_INDEX_FILE; \
236         rm -f $${GIT_INDEX_FILE} && \
237         git add -f Documentation/*.1 && \
238         git update-ref refs/heads/man \
239                 $$(echo "Autogenerated man pages for $$(git describe --always)" \
240                     | git commit-tree $$(git write-tree --prefix=Documentation) \
241                                 -p refs/heads/man) && \
242         rm -f $${GIT_INDEX_FILE} && \
243         git add -f Documentation/*.html && \
244         git update-ref refs/heads/html \
245                 $$(echo "Autogenerated html pages for $$(git describe --always)" \
246                     | git commit-tree $$(git write-tree --prefix=Documentation) \
247                                 -p refs/heads/html)
248
249 # push the pregenerated doc files to origin/man and origin/html
250 push-docs: export-docs
251         git push origin man html
252
253 # import pregenerated doc files from origin/man and origin/html, in case you
254 # don't have pandoc but still want to be able to install the docs.
255 import-docs: Documentation/clean
256         $(pf); git archive origin/html | (cd Documentation && tar -xvf -)
257         $(pf); git archive origin/man | (cd Documentation && tar -xvf -)
258
259 clean: Documentation/clean config/clean
260         rm -f *.o lib/*/*.o *.so lib/*/*.so *.dll lib/*/*.dll *.exe \
261                 .*~ *~ */*~ lib/*/*~ lib/*/*/*~ \
262                 *.pyc */*.pyc lib/*/*.pyc lib/*/*/*.pyc \
263                 bup bup-* cmd/bup-* \
264                 cmd/python-cmd.sh \
265                 randomgen memtest \
266                 testfs.img lib/bup/t/testfs.img
267         if test -e t/mnt; then t/cleanup-mounts-under t/mnt; fi
268         if test -e t/mnt; then rm -r t/mnt; fi
269         if test -e t/tmp; then t/cleanup-mounts-under t/tmp; fi
270         # FIXME: migrate these to t/mnt/
271         if test -e lib/bup/t/testfs; \
272           then umount lib/bup/t/testfs || true; fi
273         rm -rf *.tmp *.tmp.meta t/*.tmp lib/*/*/*.tmp build lib/bup/build lib/bup/t/testfs
274         if test -e t/tmp; then t/force-delete t/tmp; fi
275         ./configure-version --clean
276         t/configure-sampledata --clean